DROP TRIGGER TRAFFIC_BIR;

DROP SEQUENCE TRAFFIC_SEQ;

DROP TABLE T_DATA_TRAFFIC_INFORMATION;

CREATE TABLE T_DATA_TRAFFIC_INFORMATION (
		C_ID NUMBER(10) NOT NULL,
        C_PROVIDER VARCHAR(20),
        C_EXTID VARCHAR(100) NOT NULL,
		C_X FLOAT,
        C_Y FLOAT,
		C_XMIN FLOAT,
		C_YMIN FLOAT,
		C_XMAX FLOAT,
		C_YMAX FLOAT,
        C_CATEGORY INTEGER,
        C_COUNTRY VARCHAR(20),
        C_ROAD VARCHAR2(2000),
        C_WKBGEOMETRY BLOB NOT NULL,
        C_EXCEPTIONPATH BLOB,
        C_DESCRIPTION_EN VARCHAR2(2000),
        C_DESCRIPTION_DE VARCHAR2(2000),
        C_DESCRIPTION_FR VARCHAR2(2000),
        C_DESCRIPTION_NL VARCHAR2(2000),
        C_DESCRIPTION_IT VARCHAR2(2000),
        C_FIRSTTIME TIMESTAMP,
        C_UPDATETIME TIMESTAMP,
        C_VALIDFROM TIMESTAMP,
        C_VALIDUNTIL TIMESTAMP,
        C_XROUTEDISTANCE INTEGER,
        C_XROUTETIME INTEGER,
        C_DELAY INTEGER,
        C_LENGTH INTEGER,
        C_TMCREGIONCODE INTEGER
    );
    
CREATE SEQUENCE TRAFFIC_SEQ;   

ALTER TABLE T_DATA_TRAFFIC_INFORMATION ADD CONSTRAINT TRAFFICINFOPK PRIMARY KEY (C_ID);
CREATE UNIQUE INDEX TRAFFICINFOIDX ON T_DATA_TRAFFIC_INFORMATION (C_EXTID);

CREATE OR REPLACE TRIGGER TRAFFIC_BIR 
BEFORE INSERT ON T_DATA_TRAFFIC_INFORMATION 
FOR EACH ROW

BEGIN
  SELECT TRAFFIC_SEQ.NEXTVAL
  INTO   :new.C_ID
  FROM   dual;
END;